*
* $Id: spawn.s,v 3.5 1993/08/02 21:51:13 Jonathan Exp Jonathan $
* $Log: spawn.s,v $
* Revision 3.5  1993/08/02  21:51:13  Jonathan
* RELEASE V3.7
*
*

PROG	equ	0
COMSTR	equ	4
INFILE	equ	8
IN_ID	equ	12
OUFILE	equ	16
OU_ID	equ	20
OWNER	equ	24
STDE	equ	28
PRIO	equ	32
WAIT	equ	33

io_open 	equ	$01
io_close	equ	$02
fs_load 	equ	$48
mt_cjob 	equ	$01
mt_frjob	equ	$05
mt_activ	equ	$0a

.even
.text

_Spawn:
	move.l	4(sp),a0			;struct address
	movem.l a2-a6/d2-d7,-(sp)		;save all registers
	move.l	a0,a6				;input structure
	moveq	#1,d3				;open for read
	moveq	#-1,d1				;we own it
	move.l	PROG(a6),a1			;program name
	bsr	QLOpen				;open file
	tst.l	d0				;see if OK
	bne	l01				;its not, so quit
	lea.l	-64(sp),sp			;buffer space
	move.l	sp,a1				;push address for buffer
	bsr	RdHead				;read file header
	lea.l	64(sp),sp			;restore stack
	tst.l	d0				;see if OK
	beq	l028				;its not
	bsr	Close				;close file
	bra	l01				;and return
l028:	exg	a0,a4				;save channel ID in a4
	cmpi.b	#1,-59(a1)			;is it exec file
	bne	l02				;not, show error
	move.l	-64(a1),d2			;code size
	move.l	-58(a1),d3			;data size
	moveq	#0,d5
	moveq	#0,d6
	moveq	#0,d7
	cmpi.l	#0,COMSTR(a6)			;any command string
	beq	l09				;no, just start job
	move.l	COMSTR(a6),a1			;command string
	move.l	d2,-(sp)			;save stack size
	bsr	Str_Len 			;get length
	move.w	d2,d6				;actual size
	addq.w	#1,d2				;plus one
	andi.w	#$FFFE,d2			;make even
	move.w	d2,d7				;stack actually needed
	move.l	(sp)+,d2			;code size
l09:
	add.w	d7,d3				;plus cmd str size
	add.w	#36,d3				;for good luck !!
	move.l	#0,a1				;no code yet
	move.l	OWNER(a6),d1			;job owner
	moveq	#mt_cjob,d0			;create job
	trap	#1				;do it
	exg	a0,a4				;a0 = channel, a4 = mem alloc
	tst.l	d0				;OK
	beq	l03				;yes
	bsr	Close				;close channel
	bra	l01				;and return
l03:	move.l	a4,a1				;memory buffer
	move.l	d1,d4				;save JID
	moveq	#-1,d3				;timeout
	moveq	#fs_load,d0			;load trap
	trap	#3				;do it
	bsr	Close				;close file
	tst.l	d0				;OK ?
	beq	l04				;if OK
	move.l	d4,d1				;job id
	move.l	d0,d3				;error code
	bsr	kjob				;kill off job
	bra	l01				;and return
l04:	lea.l	-12(sp),sp			;store chids on stack
	move.l	sp,a5				;address of this block
	cmpi.l	#0,INFILE(a6)			;see if stdin required
	beq	l05				;its not
	move.l	d4,d1				;id of new job
	move.l	IN_ID(a6),d3			;d3 for input file
	moveq	#io_open,d0			;trap
	move.l	INFILE(a6),a1			;pipe name
	bsr	QLOpen				;open device
	move.l	a0,(a5)+			;save channel ID
	moveq	#1,d5				;show one channel
l05:	cmpi.l	#0,STDE(a6)
	ble	l051
	move.l	STDE(a6),(a5)+
	addi.w	#1,d5
l051:	cmpi.l	#0,OUFILE(a6)			;see if stdout required
	beq	l06				;its not
	move.l	OUFILE(a6),a1			;file name
	move.l	d4,d1				;owner
	move.l	#3,d3				;this type
	bsr	QLOpen				;open it
        cmpi.l  #-1,STDE(a6)                    ;-1 == double up stdout
        bne     l052
	move.l	a0,(a5)+
	addi.w	#1,d5
l052:
	move.l	a0,(a5) 			;save ID
	move.l	a0,OU_ID(a6)			;d3 for input pipe
	addq.w	#1,d5				;show one more channel
l06:
	move.l	sp,a5				;restore saved channels area
	exg	a4,a1				;a1 is job header
	move.l	-12(a1),a3			;jobs stack
	move.w	d5,d2				;channels
	asl.w	#2,d2				;space required
	add.w	d7,d2				;plus text size
	neg.w	d2				;negate it
	lea.l	0(a3,d2.w),a3			;new stack
	move.l	a3,-12(a1)			;save in header
	move.w	d5,(a3)+			;put on stack
l020:	subq.w	#1,d5				;loop counter
	bcs	l021
	move.l	(a5)+,(a3)+			;channel Id
	bra	l020				;loop
l021:	lea.l	12(sp),sp			;restore stack
	move.l	COMSTR(a6),a2			;text start
	move.w	d6,(a3)+			;text size
l022:	subq.w	#1,d6				;less one
	bcs	l023				;done
	move.b	(a2)+,(a3)+			;move text
	bra	l022				;loop around
l023:	move.l	d4,d1				;job ID
	move.l	d4,OWNER(a6)			;return it also
	move.b	PRIO(a6),d2			;priority
	move.b	WAIT(a6),d3			;flag
	ext.w	d3				;word wide
	moveq	#mt_activ,d0			;activate
	trap	#1				;do it
	bra	l01				;and return

l02:	moveq	#-15,d0 			;show bad parameter
l01:	movem.l (sp)+,a2-a6/d2-d7		;restore registers
	rts

Close:
	movem.l d0,-(sp)
	moveq	#io_close,d0
	trap	#2
	movem.l (sp)+,d0
	rts

kjob:	movem.l a3,-(sp)
	moveq	#mt_frjob,d0
	trap	#1
	movem.l (sp)+,a3
	rts

Str_Len:
	moveq	#0,d2
l0101:	tst.b	0(a1,d2.w)
	beq	l0102
	addq.w	#1,d2
	bra	l0101
l0102:
	rts

QLName:
	moveq	#0,d0
	bsr	Str_Len 			; get string length
	tst.w	d2
	beq	lx1
	move.l	a0,-(sp)			; save base address
	move.w	d2,(a0)+			; size
	subq.w	#1,d2				; less one for loop
l030:	move.b	(a1)+,(a0)+			; copy bytes
	dbra	d2,l030 			; loop it
	move.l	(sp)+,a0			; restore stack
	rts					; done it
lx1:	moveq	#-15,d0
	rts

QLOpen:
	lea.l	-64(sp),sp			; new stack
	move.l	sp,a0				; also for name
	bsr	QLName				; get in QL format
	tst.l	d0
	bne	lx3
	moveq	#io_open,d0			; trap function
	trap	#2				; do it
	bra	lx2
lx3:	moveq	#-15,d0
lx2:	lea.l	64(sp),sp			; sort out stack;
	rts

RdHead:
	moveq	#$47,d0
	moveq	#64,d2
	moveq	#-1,d3
	trap	#3
	rts

.globl	_Spawn
	end
